/*
 * LineBreak  ~  v.0.2  ~  NightOwl  ~  Work with the level files.
 */
import java.io.File;
import java.io.FileNotFoundException;
import java.util.ArrayList;
import java.util.List;
import java.util.Iterator;
import java.util.Scanner;
import java.util.Random;

import java.awt.Graphics;

public class Level {
    List<Brick> map = new ArrayList<Brick>();
    List<Bonus> bonuslist = new ArrayList<Bonus>();
    Iterator it;
    Brick pointer; Bonus bpointer;
    Scanner file;
    private Random rand = new Random(System.currentTimeMillis());

    public Level(String name){
        loadLevel(name);
    }

    // get
    public List<Brick> getMap(){ return map; }
    public boolean isClear(){
        for(Brick brick: map){
            if(!brick.isDestroyed()) return false;
        }
        return true;
    }

    // other
    public boolean loadLevel(String name){
        int c, i = 0;
        map.clear();
        try {
            file = new Scanner(new File(name));
        } catch (FileNotFoundException e) {
            return false;
        }
        while(file.hasNextInt()){
            c = file.nextInt();
            if(c!=0) map.add(new Brick(20+(i%Const.MAP_WIDTH)*32, 15+(i/Const.MAP_WIDTH)*22, 30, 20, c));
            i++;
        }
        file.close();
        return true;
    }
    public void generateLevel(){
        int value;
        map.clear();
        for(int x = 0; x < Const.MAP_WIDTH; x++){
            for(int y = 0; y < Const.MAP_HEIGHT; y++){
                value = rand.nextInt(8);
                if(value!=0) map.add(new Brick(20+x*32, 15+y*22, 30, 20, value));
            }
        }
    }
    public void draw(Graphics g){
        it = map.iterator();
        while(it.hasNext()){
            pointer = (Brick)it.next();
            pointer.draw(g);
        }
    }
}
